#include <errno.h>
#include <limits.h>
#include <inttypes.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

/*
 * Autogenerated file, do not edit it!
 */

 
#include <third_party/confetti/prscfg.h>
#include <cfg/tarantool_silverbox_cfg.h>
void out_warning(ConfettyError r, char *format, ...);
static int
cmpNameAtoms(NameAtom *a, NameAtom *b) {
	while(a && b) {
		if (strcasecmp(a->name, b->name) != 0)
			return 0;
		a = a->next;
		b = b->next;
	}
	return (a == NULL && b == NULL) ? 1 : 0;
}

int
fill_default_tarantool_cfg(tarantool_cfg *c) {
	c->username = NULL;
	c->coredump = 0;
	c->admin_port = 0;
	c->log_level = 4;
	c->slab_alloc_arena = 1;
	c->slab_alloc_minimal = 64;
	c->slab_alloc_factor = 2;
	c->work_dir = NULL;
	c->pid_file = strdup("tarantool.pid");
	if (c->pid_file == NULL) return CNF_NOMEMORY;
	c->logger = NULL;
	c->logger_nonblock = 1;
	c->io_collect_interval = 0;
	c->backlog = 1024;
	c->readahead = 16320;
	c->snap_dir = strdup(".");
	if (c->snap_dir == NULL) return CNF_NOMEMORY;
	c->wal_dir = strdup(".");
	if (c->wal_dir == NULL) return CNF_NOMEMORY;
	c->primary_port = 0;
	c->secondary_port = 0;
	c->too_long_threshold = 0.5;
	c->custom_proc_title = NULL;
	c->memcached = 0;
	c->memcached_namespace = 23;
	c->memcached_expire_per_loop = 1024;
	c->memcached_expire_full_sweep = 3600;
	c->snap_io_rate_limit = 0;
	c->rows_per_wal = 500000;
	c->wal_fsync_delay = 0;
	c->wal_writer_inbox_size = 128;
	c->local_hot_standby = 0;
	c->wal_dir_rescan_delay = 0.1;
	c->panic_on_snap_error = 1;
	c->panic_on_wal_error = 0;
	c->remote_hot_standby = 0;
	c->wal_feeder_ipaddr = NULL;
	c->wal_feeder_port = 0;
	c->namespace = NULL;
	return 0;
}

static int
acceptDefault_name__namespace(tarantool_cfg_namespace *c) {
	c->enabled = 0;
	c->cardinality = -1;
	c->estimated_rows = 0;
	c->index = NULL;
	return 0;
}

static int
acceptDefault_name__namespace__index(tarantool_cfg_namespace_index *c) {
	c->type = strdup("");
	if (c->type == NULL) return CNF_NOMEMORY;
	c->unique = -1;
	c->key_field = NULL;
	return 0;
}

static int
acceptDefault_name__namespace__index__key_field(tarantool_cfg_namespace_index_key_field *c) {
	c->fieldno = -1;
	c->type = strdup("");
	if (c->type == NULL) return CNF_NOMEMORY;
	return 0;
}

static NameAtom _name__username[] = {
	{ "username", -1, NULL }
};
static NameAtom _name__coredump[] = {
	{ "coredump", -1, NULL }
};
static NameAtom _name__admin_port[] = {
	{ "admin_port", -1, NULL }
};
static NameAtom _name__log_level[] = {
	{ "log_level", -1, NULL }
};
static NameAtom _name__slab_alloc_arena[] = {
	{ "slab_alloc_arena", -1, NULL }
};
static NameAtom _name__slab_alloc_minimal[] = {
	{ "slab_alloc_minimal", -1, NULL }
};
static NameAtom _name__slab_alloc_factor[] = {
	{ "slab_alloc_factor", -1, NULL }
};
static NameAtom _name__work_dir[] = {
	{ "work_dir", -1, NULL }
};
static NameAtom _name__pid_file[] = {
	{ "pid_file", -1, NULL }
};
static NameAtom _name__logger[] = {
	{ "logger", -1, NULL }
};
static NameAtom _name__logger_nonblock[] = {
	{ "logger_nonblock", -1, NULL }
};
static NameAtom _name__io_collect_interval[] = {
	{ "io_collect_interval", -1, NULL }
};
static NameAtom _name__backlog[] = {
	{ "backlog", -1, NULL }
};
static NameAtom _name__readahead[] = {
	{ "readahead", -1, NULL }
};
static NameAtom _name__snap_dir[] = {
	{ "snap_dir", -1, NULL }
};
static NameAtom _name__wal_dir[] = {
	{ "wal_dir", -1, NULL }
};
static NameAtom _name__primary_port[] = {
	{ "primary_port", -1, NULL }
};
static NameAtom _name__secondary_port[] = {
	{ "secondary_port", -1, NULL }
};
static NameAtom _name__too_long_threshold[] = {
	{ "too_long_threshold", -1, NULL }
};
static NameAtom _name__custom_proc_title[] = {
	{ "custom_proc_title", -1, NULL }
};
static NameAtom _name__memcached[] = {
	{ "memcached", -1, NULL }
};
static NameAtom _name__memcached_namespace[] = {
	{ "memcached_namespace", -1, NULL }
};
static NameAtom _name__memcached_expire_per_loop[] = {
	{ "memcached_expire_per_loop", -1, NULL }
};
static NameAtom _name__memcached_expire_full_sweep[] = {
	{ "memcached_expire_full_sweep", -1, NULL }
};
static NameAtom _name__snap_io_rate_limit[] = {
	{ "snap_io_rate_limit", -1, NULL }
};
static NameAtom _name__rows_per_wal[] = {
	{ "rows_per_wal", -1, NULL }
};
static NameAtom _name__wal_fsync_delay[] = {
	{ "wal_fsync_delay", -1, NULL }
};
static NameAtom _name__wal_writer_inbox_size[] = {
	{ "wal_writer_inbox_size", -1, NULL }
};
static NameAtom _name__local_hot_standby[] = {
	{ "local_hot_standby", -1, NULL }
};
static NameAtom _name__wal_dir_rescan_delay[] = {
	{ "wal_dir_rescan_delay", -1, NULL }
};
static NameAtom _name__panic_on_snap_error[] = {
	{ "panic_on_snap_error", -1, NULL }
};
static NameAtom _name__panic_on_wal_error[] = {
	{ "panic_on_wal_error", -1, NULL }
};
static NameAtom _name__remote_hot_standby[] = {
	{ "remote_hot_standby", -1, NULL }
};
static NameAtom _name__wal_feeder_ipaddr[] = {
	{ "wal_feeder_ipaddr", -1, NULL }
};
static NameAtom _name__wal_feeder_port[] = {
	{ "wal_feeder_port", -1, NULL }
};
static NameAtom _name__namespace__enabled[] = {
	{ "namespace", -1, _name__namespace__enabled + 1 },
	{ "enabled", -1, NULL }
};
static NameAtom _name__namespace__cardinality[] = {
	{ "namespace", -1, _name__namespace__cardinality + 1 },
	{ "cardinality", -1, NULL }
};
static NameAtom _name__namespace__estimated_rows[] = {
	{ "namespace", -1, _name__namespace__estimated_rows + 1 },
	{ "estimated_rows", -1, NULL }
};
static NameAtom _name__namespace__index__type[] = {
	{ "namespace", -1, _name__namespace__index__type + 1 },
	{ "index", -1, _name__namespace__index__type + 2 },
	{ "type", -1, NULL }
};
static NameAtom _name__namespace__index__unique[] = {
	{ "namespace", -1, _name__namespace__index__unique + 1 },
	{ "index", -1, _name__namespace__index__unique + 2 },
	{ "unique", -1, NULL }
};
static NameAtom _name__namespace__index__key_field__fieldno[] = {
	{ "namespace", -1, _name__namespace__index__key_field__fieldno + 1 },
	{ "index", -1, _name__namespace__index__key_field__fieldno + 2 },
	{ "key_field", -1, _name__namespace__index__key_field__fieldno + 3 },
	{ "fieldno", -1, NULL }
};
static NameAtom _name__namespace__index__key_field__type[] = {
	{ "namespace", -1, _name__namespace__index__key_field__type + 1 },
	{ "index", -1, _name__namespace__index__key_field__type + 2 },
	{ "key_field", -1, _name__namespace__index__key_field__type + 3 },
	{ "type", -1, NULL }
};

#define ARRAYALLOC(x,n,t)  do {                                     \
   int l = 0, ar;                                                   \
   __typeof__(x) y = (x), t;                                        \
   if ( (n) <= 0 ) return CNF_WRONGINDEX; /* wrong index */         \
   while(y && *y) {                                                 \
       l++; y++;                                                    \
   }                                                                \
   if ( (n) >= l ) {                                                \
      if ( (x) == NULL )                                            \
          t = y = malloc( ((n)+1) * sizeof( __typeof__(*(x))) );    \
      else {                                                        \
          t = realloc((x), ((n)+1) * sizeof( __typeof__(*(x))) );   \
          y = t + l;                                                \
      }                                                             \
      if (t == NULL)  return CNF_NOMEMORY;                          \
      (x) = t;                                                      \
      memset(y, 0, (((n)+1) - l) * sizeof( __typeof__(*(x))) );     \
      while ( y - (x) < (n) ) {                                     \
          *y = malloc( sizeof( __typeof__(**(x))) );                \
          if (*y == NULL)  return CNF_NOMEMORY;                     \
          if ( (ar = acceptDefault##t(*y)) != 0 ) return ar;        \
          y++;                                                      \
      }                                                             \
   }                                                                \
} while(0)

static ConfettyError
acceptValue(tarantool_cfg* c, OptDef* opt, int check_rdonly) {

	if ( cmpNameAtoms( opt->name, _name__username) ) {
		if (opt->paramType != stringType )
			return CNF_WRONGTYPE;
		errno = 0;
		c->username = (opt->paramValue.stringval) ? strdup(opt->paramValue.stringval) : NULL;
		 if (opt->paramValue.stringval && c->username == NULL)
			return CNF_NOMEMORY;
	}
	else if ( cmpNameAtoms( opt->name, _name__coredump) ) {
		if (opt->paramType != numberType )
			return CNF_WRONGTYPE;
		errno = 0;
		long int i32 = strtol(opt->paramValue.numberval, NULL, 10);
		if (i32 == 0 && errno == EINVAL)
			return CNF_WRONGINT;
		if ( (i32 == LONG_MIN || i32 == LONG_MAX) && errno == ERANGE)
			return CNF_WRONGRANGE;
		c->coredump = i32;
	}
	else if ( cmpNameAtoms( opt->name, _name__admin_port) ) {
		if (opt->paramType != numberType )
			return CNF_WRONGTYPE;
		errno = 0;
		long int i32 = strtol(opt->paramValue.numberval, NULL, 10);
		if (i32 == 0 && errno == EINVAL)
			return CNF_WRONGINT;
		if ( (i32 == LONG_MIN || i32 == LONG_MAX) && errno == ERANGE)
			return CNF_WRONGRANGE;
		c->admin_port = i32;
	}
	else if ( cmpNameAtoms( opt->name, _name__log_level) ) {
		if (opt->paramType != numberType )
			return CNF_WRONGTYPE;
		errno = 0;
		long int i32 = strtol(opt->paramValue.numberval, NULL, 10);
		if (i32 == 0 && errno == EINVAL)
			return CNF_WRONGINT;
		if ( (i32 == LONG_MIN || i32 == LONG_MAX) && errno == ERANGE)
			return CNF_WRONGRANGE;
		c->log_level = i32;
	}
	else if ( cmpNameAtoms( opt->name, _name__slab_alloc_arena) ) {
		if (opt->paramType != numberType )
			return CNF_WRONGTYPE;
		errno = 0;
		c->slab_alloc_arena = strtod(opt->paramValue.numberval, NULL);
		if ( (c->slab_alloc_arena == 0 || c->slab_alloc_arena == -HUGE_VAL || c->slab_alloc_arena == HUGE_VAL) && errno == ERANGE)
			return CNF_WRONGRANGE;
	}
	else if ( cmpNameAtoms( opt->name, _name__slab_alloc_minimal) ) {
		if (opt->paramType != numberType )
			return CNF_WRONGTYPE;
		errno = 0;
		long int i32 = strtol(opt->paramValue.numberval, NULL, 10);
		if (i32 == 0 && errno == EINVAL)
			return CNF_WRONGINT;
		if ( (i32 == LONG_MIN || i32 == LONG_MAX) && errno == ERANGE)
			return CNF_WRONGRANGE;
		c->slab_alloc_minimal = i32;
	}
	else if ( cmpNameAtoms( opt->name, _name__slab_alloc_factor) ) {
		if (opt->paramType != numberType )
			return CNF_WRONGTYPE;
		errno = 0;
		c->slab_alloc_factor = strtod(opt->paramValue.numberval, NULL);
		if ( (c->slab_alloc_factor == 0 || c->slab_alloc_factor == -HUGE_VAL || c->slab_alloc_factor == HUGE_VAL) && errno == ERANGE)
			return CNF_WRONGRANGE;
	}
	else if ( cmpNameAtoms( opt->name, _name__work_dir) ) {
		if (opt->paramType != stringType )
			return CNF_WRONGTYPE;
		errno = 0;
		c->work_dir = (opt->paramValue.stringval) ? strdup(opt->paramValue.stringval) : NULL;
		 if (opt->paramValue.stringval && c->work_dir == NULL)
			return CNF_NOMEMORY;
	}
	else if ( cmpNameAtoms( opt->name, _name__pid_file) ) {
		if (opt->paramType != stringType )
			return CNF_WRONGTYPE;
		errno = 0;
		c->pid_file = (opt->paramValue.stringval) ? strdup(opt->paramValue.stringval) : NULL;
		 if (opt->paramValue.stringval && c->pid_file == NULL)
			return CNF_NOMEMORY;
	}
	else if ( cmpNameAtoms( opt->name, _name__logger) ) {
		if (opt->paramType != stringType )
			return CNF_WRONGTYPE;
		errno = 0;
		c->logger = (opt->paramValue.stringval) ? strdup(opt->paramValue.stringval) : NULL;
		 if (opt->paramValue.stringval && c->logger == NULL)
			return CNF_NOMEMORY;
	}
	else if ( cmpNameAtoms( opt->name, _name__logger_nonblock) ) {
		if (opt->paramType != numberType )
			return CNF_WRONGTYPE;
		errno = 0;
		long int i32 = strtol(opt->paramValue.numberval, NULL, 10);
		if (i32 == 0 && errno == EINVAL)
			return CNF_WRONGINT;
		if ( (i32 == LONG_MIN || i32 == LONG_MAX) && errno == ERANGE)
			return CNF_WRONGRANGE;
		c->logger_nonblock = i32;
	}
	else if ( cmpNameAtoms( opt->name, _name__io_collect_interval) ) {
		if (opt->paramType != numberType )
			return CNF_WRONGTYPE;
		errno = 0;
		c->io_collect_interval = strtod(opt->paramValue.numberval, NULL);
		if ( (c->io_collect_interval == 0 || c->io_collect_interval == -HUGE_VAL || c->io_collect_interval == HUGE_VAL) && errno == ERANGE)
			return CNF_WRONGRANGE;
	}
	else if ( cmpNameAtoms( opt->name, _name__backlog) ) {
		if (opt->paramType != numberType )
			return CNF_WRONGTYPE;
		errno = 0;
		long int i32 = strtol(opt->paramValue.numberval, NULL, 10);
		if (i32 == 0 && errno == EINVAL)
			return CNF_WRONGINT;
		if ( (i32 == LONG_MIN || i32 == LONG_MAX) && errno == ERANGE)
			return CNF_WRONGRANGE;
		c->backlog = i32;
	}
	else if ( cmpNameAtoms( opt->name, _name__readahead) ) {
		if (opt->paramType != numberType )
			return CNF_WRONGTYPE;
		errno = 0;
		long int i32 = strtol(opt->paramValue.numberval, NULL, 10);
		if (i32 == 0 && errno == EINVAL)
			return CNF_WRONGINT;
		if ( (i32 == LONG_MIN || i32 == LONG_MAX) && errno == ERANGE)
			return CNF_WRONGRANGE;
		c->readahead = i32;
	}
	else if ( cmpNameAtoms( opt->name, _name__snap_dir) ) {
		if (opt->paramType != stringType )
			return CNF_WRONGTYPE;
		errno = 0;
		c->snap_dir = (opt->paramValue.stringval) ? strdup(opt->paramValue.stringval) : NULL;
		 if (opt->paramValue.stringval && c->snap_dir == NULL)
			return CNF_NOMEMORY;
	}
	else if ( cmpNameAtoms( opt->name, _name__wal_dir) ) {
		if (opt->paramType != stringType )
			return CNF_WRONGTYPE;
		errno = 0;
		c->wal_dir = (opt->paramValue.stringval) ? strdup(opt->paramValue.stringval) : NULL;
		 if (opt->paramValue.stringval && c->wal_dir == NULL)
			return CNF_NOMEMORY;
	}
	else if ( cmpNameAtoms( opt->name, _name__primary_port) ) {
		if (opt->paramType != numberType )
			return CNF_WRONGTYPE;
		errno = 0;
		long int i32 = strtol(opt->paramValue.numberval, NULL, 10);
		if (i32 == 0 && errno == EINVAL)
			return CNF_WRONGINT;
		if ( (i32 == LONG_MIN || i32 == LONG_MAX) && errno == ERANGE)
			return CNF_WRONGRANGE;
		c->primary_port = i32;
	}
	else if ( cmpNameAtoms( opt->name, _name__secondary_port) ) {
		if (opt->paramType != numberType )
			return CNF_WRONGTYPE;
		errno = 0;
		long int i32 = strtol(opt->paramValue.numberval, NULL, 10);
		if (i32 == 0 && errno == EINVAL)
			return CNF_WRONGINT;
		if ( (i32 == LONG_MIN || i32 == LONG_MAX) && errno == ERANGE)
			return CNF_WRONGRANGE;
		c->secondary_port = i32;
	}
	else if ( cmpNameAtoms( opt->name, _name__too_long_threshold) ) {
		if (opt->paramType != numberType )
			return CNF_WRONGTYPE;
		errno = 0;
		c->too_long_threshold = strtod(opt->paramValue.numberval, NULL);
		if ( (c->too_long_threshold == 0 || c->too_long_threshold == -HUGE_VAL || c->too_long_threshold == HUGE_VAL) && errno == ERANGE)
			return CNF_WRONGRANGE;
	}
	else if ( cmpNameAtoms( opt->name, _name__custom_proc_title) ) {
		if (opt->paramType != stringType )
			return CNF_WRONGTYPE;
		errno = 0;
		c->custom_proc_title = (opt->paramValue.stringval) ? strdup(opt->paramValue.stringval) : NULL;
		 if (opt->paramValue.stringval && c->custom_proc_title == NULL)
			return CNF_NOMEMORY;
	}
	else if ( cmpNameAtoms( opt->name, _name__memcached) ) {
		if (opt->paramType != numberType )
			return CNF_WRONGTYPE;
		errno = 0;
		long int i32 = strtol(opt->paramValue.numberval, NULL, 10);
		if (i32 == 0 && errno == EINVAL)
			return CNF_WRONGINT;
		if ( (i32 == LONG_MIN || i32 == LONG_MAX) && errno == ERANGE)
			return CNF_WRONGRANGE;
		c->memcached = i32;
	}
	else if ( cmpNameAtoms( opt->name, _name__memcached_namespace) ) {
		if (opt->paramType != numberType )
			return CNF_WRONGTYPE;
		errno = 0;
		long int i32 = strtol(opt->paramValue.numberval, NULL, 10);
		if (i32 == 0 && errno == EINVAL)
			return CNF_WRONGINT;
		if ( (i32 == LONG_MIN || i32 == LONG_MAX) && errno == ERANGE)
			return CNF_WRONGRANGE;
		c->memcached_namespace = i32;
	}
	else if ( cmpNameAtoms( opt->name, _name__memcached_expire_per_loop) ) {
		if (opt->paramType != numberType )
			return CNF_WRONGTYPE;
		errno = 0;
		long int i32 = strtol(opt->paramValue.numberval, NULL, 10);
		if (i32 == 0 && errno == EINVAL)
			return CNF_WRONGINT;
		if ( (i32 == LONG_MIN || i32 == LONG_MAX) && errno == ERANGE)
			return CNF_WRONGRANGE;
		c->memcached_expire_per_loop = i32;
	}
	else if ( cmpNameAtoms( opt->name, _name__memcached_expire_full_sweep) ) {
		if (opt->paramType != numberType )
			return CNF_WRONGTYPE;
		errno = 0;
		long int i32 = strtol(opt->paramValue.numberval, NULL, 10);
		if (i32 == 0 && errno == EINVAL)
			return CNF_WRONGINT;
		if ( (i32 == LONG_MIN || i32 == LONG_MAX) && errno == ERANGE)
			return CNF_WRONGRANGE;
		c->memcached_expire_full_sweep = i32;
	}
	else if ( cmpNameAtoms( opt->name, _name__snap_io_rate_limit) ) {
		if (opt->paramType != numberType )
			return CNF_WRONGTYPE;
		errno = 0;
		c->snap_io_rate_limit = strtod(opt->paramValue.numberval, NULL);
		if ( (c->snap_io_rate_limit == 0 || c->snap_io_rate_limit == -HUGE_VAL || c->snap_io_rate_limit == HUGE_VAL) && errno == ERANGE)
			return CNF_WRONGRANGE;
	}
	else if ( cmpNameAtoms( opt->name, _name__rows_per_wal) ) {
		if (opt->paramType != numberType )
			return CNF_WRONGTYPE;
		errno = 0;
		long int i32 = strtol(opt->paramValue.numberval, NULL, 10);
		if (i32 == 0 && errno == EINVAL)
			return CNF_WRONGINT;
		if ( (i32 == LONG_MIN || i32 == LONG_MAX) && errno == ERANGE)
			return CNF_WRONGRANGE;
		c->rows_per_wal = i32;
	}
	else if ( cmpNameAtoms( opt->name, _name__wal_fsync_delay) ) {
		if (opt->paramType != numberType )
			return CNF_WRONGTYPE;
		errno = 0;
		long int i32 = strtol(opt->paramValue.numberval, NULL, 10);
		if (i32 == 0 && errno == EINVAL)
			return CNF_WRONGINT;
		if ( (i32 == LONG_MIN || i32 == LONG_MAX) && errno == ERANGE)
			return CNF_WRONGRANGE;
		c->wal_fsync_delay = i32;
	}
	else if ( cmpNameAtoms( opt->name, _name__wal_writer_inbox_size) ) {
		if (opt->paramType != numberType )
			return CNF_WRONGTYPE;
		errno = 0;
		long int i32 = strtol(opt->paramValue.numberval, NULL, 10);
		if (i32 == 0 && errno == EINVAL)
			return CNF_WRONGINT;
		if ( (i32 == LONG_MIN || i32 == LONG_MAX) && errno == ERANGE)
			return CNF_WRONGRANGE;
		c->wal_writer_inbox_size = i32;
	}
	else if ( cmpNameAtoms( opt->name, _name__local_hot_standby) ) {
		if (opt->paramType != numberType )
			return CNF_WRONGTYPE;
		errno = 0;
		long int i32 = strtol(opt->paramValue.numberval, NULL, 10);
		if (i32 == 0 && errno == EINVAL)
			return CNF_WRONGINT;
		if ( (i32 == LONG_MIN || i32 == LONG_MAX) && errno == ERANGE)
			return CNF_WRONGRANGE;
		c->local_hot_standby = i32;
	}
	else if ( cmpNameAtoms( opt->name, _name__wal_dir_rescan_delay) ) {
		if (opt->paramType != numberType )
			return CNF_WRONGTYPE;
		errno = 0;
		c->wal_dir_rescan_delay = strtod(opt->paramValue.numberval, NULL);
		if ( (c->wal_dir_rescan_delay == 0 || c->wal_dir_rescan_delay == -HUGE_VAL || c->wal_dir_rescan_delay == HUGE_VAL) && errno == ERANGE)
			return CNF_WRONGRANGE;
	}
	else if ( cmpNameAtoms( opt->name, _name__panic_on_snap_error) ) {
		if (opt->paramType != numberType )
			return CNF_WRONGTYPE;
		errno = 0;
		long int i32 = strtol(opt->paramValue.numberval, NULL, 10);
		if (i32 == 0 && errno == EINVAL)
			return CNF_WRONGINT;
		if ( (i32 == LONG_MIN || i32 == LONG_MAX) && errno == ERANGE)
			return CNF_WRONGRANGE;
		c->panic_on_snap_error = i32;
	}
	else if ( cmpNameAtoms( opt->name, _name__panic_on_wal_error) ) {
		if (opt->paramType != numberType )
			return CNF_WRONGTYPE;
		errno = 0;
		long int i32 = strtol(opt->paramValue.numberval, NULL, 10);
		if (i32 == 0 && errno == EINVAL)
			return CNF_WRONGINT;
		if ( (i32 == LONG_MIN || i32 == LONG_MAX) && errno == ERANGE)
			return CNF_WRONGRANGE;
		c->panic_on_wal_error = i32;
	}
	else if ( cmpNameAtoms( opt->name, _name__remote_hot_standby) ) {
		if (opt->paramType != numberType )
			return CNF_WRONGTYPE;
		errno = 0;
		long int i32 = strtol(opt->paramValue.numberval, NULL, 10);
		if (i32 == 0 && errno == EINVAL)
			return CNF_WRONGINT;
		if ( (i32 == LONG_MIN || i32 == LONG_MAX) && errno == ERANGE)
			return CNF_WRONGRANGE;
		c->remote_hot_standby = i32;
	}
	else if ( cmpNameAtoms( opt->name, _name__wal_feeder_ipaddr) ) {
		if (opt->paramType != stringType )
			return CNF_WRONGTYPE;
		errno = 0;
		c->wal_feeder_ipaddr = (opt->paramValue.stringval) ? strdup(opt->paramValue.stringval) : NULL;
		 if (opt->paramValue.stringval && c->wal_feeder_ipaddr == NULL)
			return CNF_NOMEMORY;
	}
	else if ( cmpNameAtoms( opt->name, _name__wal_feeder_port) ) {
		if (opt->paramType != numberType )
			return CNF_WRONGTYPE;
		errno = 0;
		long int i32 = strtol(opt->paramValue.numberval, NULL, 10);
		if (i32 == 0 && errno == EINVAL)
			return CNF_WRONGINT;
		if ( (i32 == LONG_MIN || i32 == LONG_MAX) && errno == ERANGE)
			return CNF_WRONGRANGE;
		c->wal_feeder_port = i32;
	}
	else if ( cmpNameAtoms( opt->name, _name__namespace__enabled) ) {
		if (opt->paramType != numberType )
			return CNF_WRONGTYPE;
		ARRAYALLOC(c->namespace, opt->name->index + 1, _name__namespace);
		errno = 0;
		long int i32 = strtol(opt->paramValue.numberval, NULL, 10);
		if (i32 == 0 && errno == EINVAL)
			return CNF_WRONGINT;
		if ( (i32 == LONG_MIN || i32 == LONG_MAX) && errno == ERANGE)
			return CNF_WRONGRANGE;
		c->namespace[opt->name->index]->enabled = i32;
	}
	else if ( cmpNameAtoms( opt->name, _name__namespace__cardinality) ) {
		if (opt->paramType != numberType )
			return CNF_WRONGTYPE;
		ARRAYALLOC(c->namespace, opt->name->index + 1, _name__namespace);
		errno = 0;
		long int i32 = strtol(opt->paramValue.numberval, NULL, 10);
		if (i32 == 0 && errno == EINVAL)
			return CNF_WRONGINT;
		if ( (i32 == LONG_MIN || i32 == LONG_MAX) && errno == ERANGE)
			return CNF_WRONGRANGE;
		c->namespace[opt->name->index]->cardinality = i32;
	}
	else if ( cmpNameAtoms( opt->name, _name__namespace__estimated_rows) ) {
		if (opt->paramType != numberType )
			return CNF_WRONGTYPE;
		ARRAYALLOC(c->namespace, opt->name->index + 1, _name__namespace);
		errno = 0;
		long int i32 = strtol(opt->paramValue.numberval, NULL, 10);
		if (i32 == 0 && errno == EINVAL)
			return CNF_WRONGINT;
		if ( (i32 == LONG_MIN || i32 == LONG_MAX) && errno == ERANGE)
			return CNF_WRONGRANGE;
		c->namespace[opt->name->index]->estimated_rows = i32;
	}
	else if ( cmpNameAtoms( opt->name, _name__namespace__index__type) ) {
		if (opt->paramType != stringType )
			return CNF_WRONGTYPE;
		ARRAYALLOC(c->namespace, opt->name->index + 1, _name__namespace);
		ARRAYALLOC(c->namespace[opt->name->index]->index, opt->name->next->index + 1, _name__namespace__index);
		errno = 0;
		c->namespace[opt->name->index]->index[opt->name->next->index]->type = (opt->paramValue.stringval) ? strdup(opt->paramValue.stringval) : NULL;
		 if (opt->paramValue.stringval && c->namespace[opt->name->index]->index[opt->name->next->index]->type == NULL)
			return CNF_NOMEMORY;
	}
	else if ( cmpNameAtoms( opt->name, _name__namespace__index__unique) ) {
		if (opt->paramType != numberType )
			return CNF_WRONGTYPE;
		ARRAYALLOC(c->namespace, opt->name->index + 1, _name__namespace);
		ARRAYALLOC(c->namespace[opt->name->index]->index, opt->name->next->index + 1, _name__namespace__index);
		errno = 0;
		long int i32 = strtol(opt->paramValue.numberval, NULL, 10);
		if (i32 == 0 && errno == EINVAL)
			return CNF_WRONGINT;
		if ( (i32 == LONG_MIN || i32 == LONG_MAX) && errno == ERANGE)
			return CNF_WRONGRANGE;
		c->namespace[opt->name->index]->index[opt->name->next->index]->unique = i32;
	}
	else if ( cmpNameAtoms( opt->name, _name__namespace__index__key_field__fieldno) ) {
		if (opt->paramType != numberType )
			return CNF_WRONGTYPE;
		ARRAYALLOC(c->namespace, opt->name->index + 1, _name__namespace);
		ARRAYALLOC(c->namespace[opt->name->index]->index, opt->name->next->index + 1, _name__namespace__index);
		ARRAYALLOC(c->namespace[opt->name->index]->index[opt->name->next->index]->key_field, opt->name->next->next->index + 1, _name__namespace__index__key_field);
		errno = 0;
		long int i32 = strtol(opt->paramValue.numberval, NULL, 10);
		if (i32 == 0 && errno == EINVAL)
			return CNF_WRONGINT;
		if ( (i32 == LONG_MIN || i32 == LONG_MAX) && errno == ERANGE)
			return CNF_WRONGRANGE;
		c->namespace[opt->name->index]->index[opt->name->next->index]->key_field[opt->name->next->next->index]->fieldno = i32;
	}
	else if ( cmpNameAtoms( opt->name, _name__namespace__index__key_field__type) ) {
		if (opt->paramType != stringType )
			return CNF_WRONGTYPE;
		ARRAYALLOC(c->namespace, opt->name->index + 1, _name__namespace);
		ARRAYALLOC(c->namespace[opt->name->index]->index, opt->name->next->index + 1, _name__namespace__index);
		ARRAYALLOC(c->namespace[opt->name->index]->index[opt->name->next->index]->key_field, opt->name->next->next->index + 1, _name__namespace__index__key_field);
		errno = 0;
		c->namespace[opt->name->index]->index[opt->name->next->index]->key_field[opt->name->next->next->index]->type = (opt->paramValue.stringval) ? strdup(opt->paramValue.stringval) : NULL;
		 if (opt->paramValue.stringval && c->namespace[opt->name->index]->index[opt->name->next->index]->key_field[opt->name->next->next->index]->type == NULL)
			return CNF_NOMEMORY;
	}
	else {
		return CNF_MISSED;
	}
	return CNF_OK;
}

#define PRINTBUFLEN	8192
static char*
dumpOptDef(NameAtom *atom) {
	static char	buf[PRINTBUFLEN], *ptr;
	int  i = 0;

	ptr = buf;
	while(atom) {
		if (i) ptr += snprintf(ptr, PRINTBUFLEN - 1 - (ptr - buf), ".");
		ptr += snprintf(ptr, PRINTBUFLEN - 1 - (ptr - buf), "%s", atom->name);
		if (atom->index >= 0)
			ptr += snprintf(ptr, PRINTBUFLEN - 1 - (ptr - buf), "[%d]", atom->index);
		i = 1;
		atom = atom->next;
	}
	return buf;
}

static void
acceptCfgDef(tarantool_cfg *c, OptDef *opt, int check_rdonly, int *n_accepted, int *n_skipped) {
	ConfettyError	r;

	if (n_accepted) *n_accepted=0;
	if (n_skipped) *n_skipped=0;

	while(opt) {
		r = acceptValue(c, opt, check_rdonly);
		switch(r) {
			case CNF_OK:
				if (n_accepted) (*n_accepted)++;
				break;
			case CNF_MISSED:
				out_warning(r, "Could not find '%s' option", dumpOptDef(opt->name));
				if (n_skipped) (*n_skipped)++;
				break;
			case CNF_WRONGTYPE:
				out_warning(r, "Wrong value type for '%s' option", dumpOptDef(opt->name));
				if (n_skipped) (*n_skipped)++;
				break;
			case CNF_WRONGINDEX:
				out_warning(r, "Wrong array index in '%s' option", dumpOptDef(opt->name));
				if (n_skipped) (*n_skipped)++;
				break;
			case CNF_RDONLY:
				out_warning(r, "Could not accept read only '%s' option", dumpOptDef(opt->name));
				if (n_skipped) (*n_skipped)++;
				break;
			case CNF_WRONGINT:
				out_warning(r, "Could not parse integer value for '%s' option", dumpOptDef(opt->name));
				if (n_skipped) (*n_skipped)++;
				break;
			case CNF_WRONGRANGE:
				out_warning(r, "Wrong range for '%s' option", dumpOptDef(opt->name));
				if (n_skipped) (*n_skipped)++;
				break;
			case CNF_NOMEMORY:
				out_warning(r, "Not enough memory to accept '%s' option", dumpOptDef(opt->name));
				if (n_skipped) (*n_skipped)++;
				break;
			default:
				out_warning(r, "Unknown error for '%s' option", dumpOptDef(opt->name));
				if (n_skipped) (*n_skipped)++;
				break;
		}

		opt = opt->next;
	}
}

void
parse_cfg_file_tarantool_cfg(tarantool_cfg *c, FILE *fh, int check_rdonly, int *n_accepted, int *n_skipped) {
	OptDef *option;

	option = parseCfgDef(fh);
	acceptCfgDef(c, option, check_rdonly, n_accepted, n_skipped);
	freeCfgDef(option);
}

void
parse_cfg_buffer_tarantool_cfg(tarantool_cfg *c, char *buffer, int check_rdonly, int *n_accepted, int *n_skipped) {
	OptDef *option;

	option = parseCfgDefBuffer(buffer);
	acceptCfgDef(c, option, check_rdonly, n_accepted, n_skipped);
	freeCfgDef(option);
}

/************** Iterator **************/
typedef enum IteratorState {
	_S_Initial = 0,
	S_name__username,
	S_name__coredump,
	S_name__admin_port,
	S_name__log_level,
	S_name__slab_alloc_arena,
	S_name__slab_alloc_minimal,
	S_name__slab_alloc_factor,
	S_name__work_dir,
	S_name__pid_file,
	S_name__logger,
	S_name__logger_nonblock,
	S_name__io_collect_interval,
	S_name__backlog,
	S_name__readahead,
	S_name__snap_dir,
	S_name__wal_dir,
	S_name__primary_port,
	S_name__secondary_port,
	S_name__too_long_threshold,
	S_name__custom_proc_title,
	S_name__memcached,
	S_name__memcached_namespace,
	S_name__memcached_expire_per_loop,
	S_name__memcached_expire_full_sweep,
	S_name__snap_io_rate_limit,
	S_name__rows_per_wal,
	S_name__wal_fsync_delay,
	S_name__wal_writer_inbox_size,
	S_name__local_hot_standby,
	S_name__wal_dir_rescan_delay,
	S_name__panic_on_snap_error,
	S_name__panic_on_wal_error,
	S_name__remote_hot_standby,
	S_name__wal_feeder_ipaddr,
	S_name__wal_feeder_port,
	S_name__namespace,
	S_name__namespace__enabled,
	S_name__namespace__cardinality,
	S_name__namespace__estimated_rows,
	S_name__namespace__index,
	S_name__namespace__index__type,
	S_name__namespace__index__unique,
	S_name__namespace__index__key_field,
	S_name__namespace__index__key_field__fieldno,
	S_name__namespace__index__key_field__type,
	_S_Finished
} IteratorState;

struct tarantool_cfg_iterator_t {
	IteratorState	state;
	int	idx_name__namespace;
	int	idx_name__namespace__index;
	int	idx_name__namespace__index__key_field;
};

tarantool_cfg_iterator_t*
tarantool_cfg_iterator_init() {
	tarantool_cfg_iterator_t *i = malloc(sizeof(*i));
	if (i == NULL) return NULL;
	memset(i, 0, sizeof(*i));
	return i;
}

char*
tarantool_cfg_iterator_next(tarantool_cfg_iterator_t* i, tarantool_cfg *c, char **v) {
	static char	buf[PRINTBUFLEN];

	*v = NULL;
	goto again; /* keep compiler quiet */
again:
	switch(i->state) {
		case _S_Initial:
		case S_name__username:
			*v = (c->username) ? strdup(c->username) : NULL;
			if (*v == NULL && c->username) {
				free(i);
				out_warning(CNF_NOMEMORY, "No memory to output value");
				return NULL;
			}
			snprintf(buf, PRINTBUFLEN-1, "username");
			i->state = S_name__coredump;
			return buf;
		case S_name__coredump:
			*v = malloc(32);
			if (*v == NULL) {
				free(i);
				out_warning(CNF_NOMEMORY, "No memory to output value");
				return NULL;
			}
			sprintf(*v, "%"PRId32, c->coredump);
			snprintf(buf, PRINTBUFLEN-1, "coredump");
			i->state = S_name__admin_port;
			return buf;
		case S_name__admin_port:
			*v = malloc(32);
			if (*v == NULL) {
				free(i);
				out_warning(CNF_NOMEMORY, "No memory to output value");
				return NULL;
			}
			sprintf(*v, "%"PRId32, c->admin_port);
			snprintf(buf, PRINTBUFLEN-1, "admin_port");
			i->state = S_name__log_level;
			return buf;
		case S_name__log_level:
			*v = malloc(32);
			if (*v == NULL) {
				free(i);
				out_warning(CNF_NOMEMORY, "No memory to output value");
				return NULL;
			}
			sprintf(*v, "%"PRId32, c->log_level);
			snprintf(buf, PRINTBUFLEN-1, "log_level");
			i->state = S_name__slab_alloc_arena;
			return buf;
		case S_name__slab_alloc_arena:
			*v = malloc(32);
			if (*v == NULL) {
				free(i);
				out_warning(CNF_NOMEMORY, "No memory to output value");
				return NULL;
			}
			sprintf(*v, "%g", c->slab_alloc_arena);
			snprintf(buf, PRINTBUFLEN-1, "slab_alloc_arena");
			i->state = S_name__slab_alloc_minimal;
			return buf;
		case S_name__slab_alloc_minimal:
			*v = malloc(32);
			if (*v == NULL) {
				free(i);
				out_warning(CNF_NOMEMORY, "No memory to output value");
				return NULL;
			}
			sprintf(*v, "%"PRId32, c->slab_alloc_minimal);
			snprintf(buf, PRINTBUFLEN-1, "slab_alloc_minimal");
			i->state = S_name__slab_alloc_factor;
			return buf;
		case S_name__slab_alloc_factor:
			*v = malloc(32);
			if (*v == NULL) {
				free(i);
				out_warning(CNF_NOMEMORY, "No memory to output value");
				return NULL;
			}
			sprintf(*v, "%g", c->slab_alloc_factor);
			snprintf(buf, PRINTBUFLEN-1, "slab_alloc_factor");
			i->state = S_name__work_dir;
			return buf;
		case S_name__work_dir:
			*v = (c->work_dir) ? strdup(c->work_dir) : NULL;
			if (*v == NULL && c->work_dir) {
				free(i);
				out_warning(CNF_NOMEMORY, "No memory to output value");
				return NULL;
			}
			snprintf(buf, PRINTBUFLEN-1, "work_dir");
			i->state = S_name__pid_file;
			return buf;
		case S_name__pid_file:
			*v = (c->pid_file) ? strdup(c->pid_file) : NULL;
			if (*v == NULL && c->pid_file) {
				free(i);
				out_warning(CNF_NOMEMORY, "No memory to output value");
				return NULL;
			}
			snprintf(buf, PRINTBUFLEN-1, "pid_file");
			i->state = S_name__logger;
			return buf;
		case S_name__logger:
			*v = (c->logger) ? strdup(c->logger) : NULL;
			if (*v == NULL && c->logger) {
				free(i);
				out_warning(CNF_NOMEMORY, "No memory to output value");
				return NULL;
			}
			snprintf(buf, PRINTBUFLEN-1, "logger");
			i->state = S_name__logger_nonblock;
			return buf;
		case S_name__logger_nonblock:
			*v = malloc(32);
			if (*v == NULL) {
				free(i);
				out_warning(CNF_NOMEMORY, "No memory to output value");
				return NULL;
			}
			sprintf(*v, "%"PRId32, c->logger_nonblock);
			snprintf(buf, PRINTBUFLEN-1, "logger_nonblock");
			i->state = S_name__io_collect_interval;
			return buf;
		case S_name__io_collect_interval:
			*v = malloc(32);
			if (*v == NULL) {
				free(i);
				out_warning(CNF_NOMEMORY, "No memory to output value");
				return NULL;
			}
			sprintf(*v, "%g", c->io_collect_interval);
			snprintf(buf, PRINTBUFLEN-1, "io_collect_interval");
			i->state = S_name__backlog;
			return buf;
		case S_name__backlog:
			*v = malloc(32);
			if (*v == NULL) {
				free(i);
				out_warning(CNF_NOMEMORY, "No memory to output value");
				return NULL;
			}
			sprintf(*v, "%"PRId32, c->backlog);
			snprintf(buf, PRINTBUFLEN-1, "backlog");
			i->state = S_name__readahead;
			return buf;
		case S_name__readahead:
			*v = malloc(32);
			if (*v == NULL) {
				free(i);
				out_warning(CNF_NOMEMORY, "No memory to output value");
				return NULL;
			}
			sprintf(*v, "%"PRId32, c->readahead);
			snprintf(buf, PRINTBUFLEN-1, "readahead");
			i->state = S_name__snap_dir;
			return buf;
		case S_name__snap_dir:
			*v = (c->snap_dir) ? strdup(c->snap_dir) : NULL;
			if (*v == NULL && c->snap_dir) {
				free(i);
				out_warning(CNF_NOMEMORY, "No memory to output value");
				return NULL;
			}
			snprintf(buf, PRINTBUFLEN-1, "snap_dir");
			i->state = S_name__wal_dir;
			return buf;
		case S_name__wal_dir:
			*v = (c->wal_dir) ? strdup(c->wal_dir) : NULL;
			if (*v == NULL && c->wal_dir) {
				free(i);
				out_warning(CNF_NOMEMORY, "No memory to output value");
				return NULL;
			}
			snprintf(buf, PRINTBUFLEN-1, "wal_dir");
			i->state = S_name__primary_port;
			return buf;
		case S_name__primary_port:
			*v = malloc(32);
			if (*v == NULL) {
				free(i);
				out_warning(CNF_NOMEMORY, "No memory to output value");
				return NULL;
			}
			sprintf(*v, "%"PRId32, c->primary_port);
			snprintf(buf, PRINTBUFLEN-1, "primary_port");
			i->state = S_name__secondary_port;
			return buf;
		case S_name__secondary_port:
			*v = malloc(32);
			if (*v == NULL) {
				free(i);
				out_warning(CNF_NOMEMORY, "No memory to output value");
				return NULL;
			}
			sprintf(*v, "%"PRId32, c->secondary_port);
			snprintf(buf, PRINTBUFLEN-1, "secondary_port");
			i->state = S_name__too_long_threshold;
			return buf;
		case S_name__too_long_threshold:
			*v = malloc(32);
			if (*v == NULL) {
				free(i);
				out_warning(CNF_NOMEMORY, "No memory to output value");
				return NULL;
			}
			sprintf(*v, "%g", c->too_long_threshold);
			snprintf(buf, PRINTBUFLEN-1, "too_long_threshold");
			i->state = S_name__custom_proc_title;
			return buf;
		case S_name__custom_proc_title:
			*v = (c->custom_proc_title) ? strdup(c->custom_proc_title) : NULL;
			if (*v == NULL && c->custom_proc_title) {
				free(i);
				out_warning(CNF_NOMEMORY, "No memory to output value");
				return NULL;
			}
			snprintf(buf, PRINTBUFLEN-1, "custom_proc_title");
			i->state = S_name__memcached;
			return buf;
		case S_name__memcached:
			*v = malloc(32);
			if (*v == NULL) {
				free(i);
				out_warning(CNF_NOMEMORY, "No memory to output value");
				return NULL;
			}
			sprintf(*v, "%"PRId32, c->memcached);
			snprintf(buf, PRINTBUFLEN-1, "memcached");
			i->state = S_name__memcached_namespace;
			return buf;
		case S_name__memcached_namespace:
			*v = malloc(32);
			if (*v == NULL) {
				free(i);
				out_warning(CNF_NOMEMORY, "No memory to output value");
				return NULL;
			}
			sprintf(*v, "%"PRId32, c->memcached_namespace);
			snprintf(buf, PRINTBUFLEN-1, "memcached_namespace");
			i->state = S_name__memcached_expire_per_loop;
			return buf;
		case S_name__memcached_expire_per_loop:
			*v = malloc(32);
			if (*v == NULL) {
				free(i);
				out_warning(CNF_NOMEMORY, "No memory to output value");
				return NULL;
			}
			sprintf(*v, "%"PRId32, c->memcached_expire_per_loop);
			snprintf(buf, PRINTBUFLEN-1, "memcached_expire_per_loop");
			i->state = S_name__memcached_expire_full_sweep;
			return buf;
		case S_name__memcached_expire_full_sweep:
			*v = malloc(32);
			if (*v == NULL) {
				free(i);
				out_warning(CNF_NOMEMORY, "No memory to output value");
				return NULL;
			}
			sprintf(*v, "%"PRId32, c->memcached_expire_full_sweep);
			snprintf(buf, PRINTBUFLEN-1, "memcached_expire_full_sweep");
			i->state = S_name__snap_io_rate_limit;
			return buf;
		case S_name__snap_io_rate_limit:
			*v = malloc(32);
			if (*v == NULL) {
				free(i);
				out_warning(CNF_NOMEMORY, "No memory to output value");
				return NULL;
			}
			sprintf(*v, "%g", c->snap_io_rate_limit);
			snprintf(buf, PRINTBUFLEN-1, "snap_io_rate_limit");
			i->state = S_name__rows_per_wal;
			return buf;
		case S_name__rows_per_wal:
			*v = malloc(32);
			if (*v == NULL) {
				free(i);
				out_warning(CNF_NOMEMORY, "No memory to output value");
				return NULL;
			}
			sprintf(*v, "%"PRId32, c->rows_per_wal);
			snprintf(buf, PRINTBUFLEN-1, "rows_per_wal");
			i->state = S_name__wal_fsync_delay;
			return buf;
		case S_name__wal_fsync_delay:
			*v = malloc(32);
			if (*v == NULL) {
				free(i);
				out_warning(CNF_NOMEMORY, "No memory to output value");
				return NULL;
			}
			sprintf(*v, "%"PRId32, c->wal_fsync_delay);
			snprintf(buf, PRINTBUFLEN-1, "wal_fsync_delay");
			i->state = S_name__wal_writer_inbox_size;
			return buf;
		case S_name__wal_writer_inbox_size:
			*v = malloc(32);
			if (*v == NULL) {
				free(i);
				out_warning(CNF_NOMEMORY, "No memory to output value");
				return NULL;
			}
			sprintf(*v, "%"PRId32, c->wal_writer_inbox_size);
			snprintf(buf, PRINTBUFLEN-1, "wal_writer_inbox_size");
			i->state = S_name__local_hot_standby;
			return buf;
		case S_name__local_hot_standby:
			*v = malloc(32);
			if (*v == NULL) {
				free(i);
				out_warning(CNF_NOMEMORY, "No memory to output value");
				return NULL;
			}
			sprintf(*v, "%"PRId32, c->local_hot_standby);
			snprintf(buf, PRINTBUFLEN-1, "local_hot_standby");
			i->state = S_name__wal_dir_rescan_delay;
			return buf;
		case S_name__wal_dir_rescan_delay:
			*v = malloc(32);
			if (*v == NULL) {
				free(i);
				out_warning(CNF_NOMEMORY, "No memory to output value");
				return NULL;
			}
			sprintf(*v, "%g", c->wal_dir_rescan_delay);
			snprintf(buf, PRINTBUFLEN-1, "wal_dir_rescan_delay");
			i->state = S_name__panic_on_snap_error;
			return buf;
		case S_name__panic_on_snap_error:
			*v = malloc(32);
			if (*v == NULL) {
				free(i);
				out_warning(CNF_NOMEMORY, "No memory to output value");
				return NULL;
			}
			sprintf(*v, "%"PRId32, c->panic_on_snap_error);
			snprintf(buf, PRINTBUFLEN-1, "panic_on_snap_error");
			i->state = S_name__panic_on_wal_error;
			return buf;
		case S_name__panic_on_wal_error:
			*v = malloc(32);
			if (*v == NULL) {
				free(i);
				out_warning(CNF_NOMEMORY, "No memory to output value");
				return NULL;
			}
			sprintf(*v, "%"PRId32, c->panic_on_wal_error);
			snprintf(buf, PRINTBUFLEN-1, "panic_on_wal_error");
			i->state = S_name__remote_hot_standby;
			return buf;
		case S_name__remote_hot_standby:
			*v = malloc(32);
			if (*v == NULL) {
				free(i);
				out_warning(CNF_NOMEMORY, "No memory to output value");
				return NULL;
			}
			sprintf(*v, "%"PRId32, c->remote_hot_standby);
			snprintf(buf, PRINTBUFLEN-1, "remote_hot_standby");
			i->state = S_name__wal_feeder_ipaddr;
			return buf;
		case S_name__wal_feeder_ipaddr:
			*v = (c->wal_feeder_ipaddr) ? strdup(c->wal_feeder_ipaddr) : NULL;
			if (*v == NULL && c->wal_feeder_ipaddr) {
				free(i);
				out_warning(CNF_NOMEMORY, "No memory to output value");
				return NULL;
			}
			snprintf(buf, PRINTBUFLEN-1, "wal_feeder_ipaddr");
			i->state = S_name__wal_feeder_port;
			return buf;
		case S_name__wal_feeder_port:
			*v = malloc(32);
			if (*v == NULL) {
				free(i);
				out_warning(CNF_NOMEMORY, "No memory to output value");
				return NULL;
			}
			sprintf(*v, "%"PRId32, c->wal_feeder_port);
			snprintf(buf, PRINTBUFLEN-1, "wal_feeder_port");
			i->state = S_name__namespace;
			return buf;
		case S_name__namespace:
			i->state = S_name__namespace;
		case S_name__namespace__enabled:
		case S_name__namespace__cardinality:
		case S_name__namespace__estimated_rows:
		case S_name__namespace__index:
		case S_name__namespace__index__type:
		case S_name__namespace__index__unique:
		case S_name__namespace__index__key_field:
		case S_name__namespace__index__key_field__fieldno:
		case S_name__namespace__index__key_field__type:
			if (c->namespace && c->namespace[i->idx_name__namespace]) {
				switch(i->state) {
					case S_name__namespace:
					case S_name__namespace__enabled:
						*v = malloc(32);
						if (*v == NULL) {
							free(i);
							out_warning(CNF_NOMEMORY, "No memory to output value");
							return NULL;
						}
						sprintf(*v, "%"PRId32, c->namespace[i->idx_name__namespace]->enabled);
						snprintf(buf, PRINTBUFLEN-1, "namespace[%d].enabled", i->idx_name__namespace);
						i->state = S_name__namespace__cardinality;
						return buf;
					case S_name__namespace__cardinality:
						*v = malloc(32);
						if (*v == NULL) {
							free(i);
							out_warning(CNF_NOMEMORY, "No memory to output value");
							return NULL;
						}
						sprintf(*v, "%"PRId32, c->namespace[i->idx_name__namespace]->cardinality);
						snprintf(buf, PRINTBUFLEN-1, "namespace[%d].cardinality", i->idx_name__namespace);
						i->state = S_name__namespace__estimated_rows;
						return buf;
					case S_name__namespace__estimated_rows:
						*v = malloc(32);
						if (*v == NULL) {
							free(i);
							out_warning(CNF_NOMEMORY, "No memory to output value");
							return NULL;
						}
						sprintf(*v, "%"PRId32, c->namespace[i->idx_name__namespace]->estimated_rows);
						snprintf(buf, PRINTBUFLEN-1, "namespace[%d].estimated_rows", i->idx_name__namespace);
						i->state = S_name__namespace__index;
						return buf;
					case S_name__namespace__index:
						i->state = S_name__namespace__index;
					case S_name__namespace__index__type:
					case S_name__namespace__index__unique:
					case S_name__namespace__index__key_field:
					case S_name__namespace__index__key_field__fieldno:
					case S_name__namespace__index__key_field__type:
						if (c->namespace[i->idx_name__namespace]->index && c->namespace[i->idx_name__namespace]->index[i->idx_name__namespace__index]) {
							switch(i->state) {
								case S_name__namespace__index:
								case S_name__namespace__index__type:
									*v = (c->namespace[i->idx_name__namespace]->index[i->idx_name__namespace__index]->type) ? strdup(c->namespace[i->idx_name__namespace]->index[i->idx_name__namespace__index]->type) : NULL;
									if (*v == NULL && c->namespace[i->idx_name__namespace]->index[i->idx_name__namespace__index]->type) {
										free(i);
										out_warning(CNF_NOMEMORY, "No memory to output value");
										return NULL;
									}
									snprintf(buf, PRINTBUFLEN-1, "namespace[%d].index[%d].type", i->idx_name__namespace, i->idx_name__namespace__index);
									i->state = S_name__namespace__index__unique;
									return buf;
								case S_name__namespace__index__unique:
									*v = malloc(32);
									if (*v == NULL) {
										free(i);
										out_warning(CNF_NOMEMORY, "No memory to output value");
										return NULL;
									}
									sprintf(*v, "%"PRId32, c->namespace[i->idx_name__namespace]->index[i->idx_name__namespace__index]->unique);
									snprintf(buf, PRINTBUFLEN-1, "namespace[%d].index[%d].unique", i->idx_name__namespace, i->idx_name__namespace__index);
									i->state = S_name__namespace__index__key_field;
									return buf;
								case S_name__namespace__index__key_field:
									i->state = S_name__namespace__index__key_field;
								case S_name__namespace__index__key_field__fieldno:
								case S_name__namespace__index__key_field__type:
									if (c->namespace[i->idx_name__namespace]->index[i->idx_name__namespace__index]->key_field && c->namespace[i->idx_name__namespace]->index[i->idx_name__namespace__index]->key_field[i->idx_name__namespace__index__key_field]) {
										switch(i->state) {
											case S_name__namespace__index__key_field:
											case S_name__namespace__index__key_field__fieldno:
												*v = malloc(32);
												if (*v == NULL) {
													free(i);
													out_warning(CNF_NOMEMORY, "No memory to output value");
													return NULL;
												}
												sprintf(*v, "%"PRId32, c->namespace[i->idx_name__namespace]->index[i->idx_name__namespace__index]->key_field[i->idx_name__namespace__index__key_field]->fieldno);
												snprintf(buf, PRINTBUFLEN-1, "namespace[%d].index[%d].key_field[%d].fieldno", i->idx_name__namespace, i->idx_name__namespace__index, i->idx_name__namespace__index__key_field);
												i->state = S_name__namespace__index__key_field__type;
												return buf;
											case S_name__namespace__index__key_field__type:
												*v = (c->namespace[i->idx_name__namespace]->index[i->idx_name__namespace__index]->key_field[i->idx_name__namespace__index__key_field]->type) ? strdup(c->namespace[i->idx_name__namespace]->index[i->idx_name__namespace__index]->key_field[i->idx_name__namespace__index__key_field]->type) : NULL;
												if (*v == NULL && c->namespace[i->idx_name__namespace]->index[i->idx_name__namespace__index]->key_field[i->idx_name__namespace__index__key_field]->type) {
													free(i);
													out_warning(CNF_NOMEMORY, "No memory to output value");
													return NULL;
												}
												snprintf(buf, PRINTBUFLEN-1, "namespace[%d].index[%d].key_field[%d].type", i->idx_name__namespace, i->idx_name__namespace__index, i->idx_name__namespace__index__key_field);
												i->state = S_name__namespace__index__key_field;
												i->idx_name__namespace__index__key_field++;
												return buf;
											default:
												break;
										}
									}
									else {
										i->state = S_name__namespace__index;
										i->idx_name__namespace__index++;
										i->idx_name__namespace__index__key_field = 0;
										goto again;
									}
								default:
									break;
							}
						}
						else {
							i->state = S_name__namespace;
							i->idx_name__namespace++;
							i->idx_name__namespace__index = 0;
							i->idx_name__namespace__index__key_field = 0;
							goto again;
						}
					default:
						break;
				}
			}
		case _S_Finished:
			free(i);
			break;
		default:
			out_warning(CNF_INTERNALERROR, "Unknown state for tarantool_cfg_iterator_t: %d", i->state);
			free(i);
	}
	return NULL;
}

